﻿using System;
 using System.Drawing;
 using System.Windows.Forms;

 /********************
إطا  Constants
خاص بكتابة الثوابت
********************/
static class Constants
 {
 public const String ApplicationName = "تشغيل ملفات WAV"; // اسم البرنامج
public const String TextBoxFontName = "Times New Roman"; // نوع الحرف لمربع التحرير
public const int TextBoxFontSize = 10; // حجم حرف مربع التحرير
public const int TextBoxWidth = 300; // عرض مربع التحرير
public const int TextBoxHeight = 25; // ارتفاع مربع التحرير
public const String ButtonFontName = "Times New Roman"; // نوع الحرف للأزرار
public const int ButtonFontSize = 9; // حجم حرف الأزرار
public const int ButtonWidth = 150; // عرض الأزرار
public const int ButtonHeight = TextBoxHeight; // ارتفاع الأزرار
public const String FileName = "Test.wav"; // اسم ملف WAVE الذي يتم تشغيله
}

 /********************
إطار test
نقطة بداية تنفيذ البرنامج
********************/
class test
 {
 public static void Main()
 {
 Application.Run(new Form1());
 }
 }

 /********************
إطار Form1
********************/
class Form1 : Form
 {
 private TextBox textbox;
 private Button button;
 private System.Media.SoundPlayer player = null;
 /* إنشاء الويندوز */
public Form1()
 {
 FormDesign();
 }
 /* حزمة FormDesign */
 /* تصميم الويندوز والعناصر المستخدمة */
public void FormDesign()
 {
 StartPosition = FormStartPosition.CenterScreen;
 MaximizeBox = false; // تعطيل خاثية تكبير الشاشة
FormBorderStyle = FormBorderStyle.Fixed3D; // تعطيل خاصية تغيير حجم شاشة البرنامج
Text = Constants.ApplicationName;
 BackColor = SystemColors.Window;
 ClientSize = new Size(Constants.TextBoxWidth + Constants.ButtonWidth, Constants.ButtonHeight);
 // إنشاء مربع التحرير
textbox = new TextBox();
 textbox.Font = new Font(Constants.TextBoxFontName, Constants.TextBoxFontSize);
 textbox.Width = Constants.TextBoxWidth;
 textbox.Height = Constants.TextBoxHeight;
 textbox.Text = Constants.FileName;
 textbox.Multiline = false; // تعطيل خاثية تعدد الأسطر
textbox.TextAlign = HorizontalAlignment.Left; // جعلها على اليسار
textbox.Parent = this;
 textbox.Location = new Point(0, 0);
 textbox.TabIndex = 0;
 textbox.TabStop = true;
 // إنشاء الزر
button = new Button();
 button.Font = new Font(Constants.ButtonFontName, Constants.ButtonFontSize);
 button.TextAlign = ContentAlignment.MiddleCenter; // جعلها في مركز الوسط
button.Width = Constants.ButtonWidth;
 button.Height = Constants.ButtonHeight;
 button.Text = "تشغيل / إيقاف";
button.BackColor = SystemColors.Control;
 button.Parent = this;
 button.Location = new Point(Constants.TextBoxWidth, 0);
 button.Click += new EventHandler(ButtonClick);
 button.TabIndex = 1;
 button.TabStop = true;
 }
 /* حزمة تنفيذ الزر */
 /* يتم تنفيذها بعد الضغط على الزر */
public void ButtonClick(object sender, EventArgs e)
 {
 String filepath = "";
 if (player == null)
 {
 filepath = textbox.Text;
 PlaySound(filepath);
 }
 else
 {
 StopSound();
 }
 }
 /* حزمة PlaySound */
 /* حزة تشغيل ملف WAVE */
private void PlaySound(string wavefile)
 {
 player = new System.Media.SoundPlayer(wavefile); // فتح الملف
// التشغيل في خلفية البرنامج
// يتم تشغيل الملف من الخلفية يمكن إجراء أي أوامر أخرى أثناء تشغيل الملف
// player.Play();// إذا حزفنا علامة التعليق واستخدمنا هذا السطر للتنفيذ يتم تشغيل الملف مرة واحدة فقط
 // لكننا سوف نستخدم خاثية تكرار التشغيل كما هو موضح في ما يلي
// بهذه الطريقة يتم تشغيل المف من الخلفية وعند الإنتهاء يتم إعادة تشغيل الملف مرة أخرى 
player.PlayLooping();
 // وإذا كتبناها كما يلي يتم تشغيل الملف إلى الآخر لكن لا يمكن تنفيذ أي أوامر أثناء التشغغيل
// player.PlaySync();
 }
 /* حزمة StopSound */
 /* يتم إيقاف تشغيل الملف */
private void StopSound()
 {
 if (player != null)
 {
 player.Stop();
 player.Dispose();
 player = null;
 }
 }
 /* حزمة OnFormClosing */
 /* يتم طلب هذه الحزمة تلقائيا عند الخروج من البرنامج */
protected override void OnFormClosing(FormClosingEventArgs e)
 {
 base.OnFormClosing(e);
 StopSound();
 e.Cancel = false;
 }
 } 
